# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetAutoScalingConfigurationResult',
    'AwaitableGetAutoScalingConfigurationResult',
    'get_auto_scaling_configuration',
    'get_auto_scaling_configuration_output',
]

@pulumi.output_type
class GetAutoScalingConfigurationResult:
    def __init__(__self__, auto_scaling_configuration_arn=None, auto_scaling_configuration_revision=None, latest=None):
        if auto_scaling_configuration_arn and not isinstance(auto_scaling_configuration_arn, str):
            raise TypeError("Expected argument 'auto_scaling_configuration_arn' to be a str")
        pulumi.set(__self__, "auto_scaling_configuration_arn", auto_scaling_configuration_arn)
        if auto_scaling_configuration_revision and not isinstance(auto_scaling_configuration_revision, int):
            raise TypeError("Expected argument 'auto_scaling_configuration_revision' to be a int")
        pulumi.set(__self__, "auto_scaling_configuration_revision", auto_scaling_configuration_revision)
        if latest and not isinstance(latest, bool):
            raise TypeError("Expected argument 'latest' to be a bool")
        pulumi.set(__self__, "latest", latest)

    @property
    @pulumi.getter(name="autoScalingConfigurationArn")
    def auto_scaling_configuration_arn(self) -> Optional[str]:
        """
        The Amazon Resource Name (ARN) of this auto scaling configuration.
        """
        return pulumi.get(self, "auto_scaling_configuration_arn")

    @property
    @pulumi.getter(name="autoScalingConfigurationRevision")
    def auto_scaling_configuration_revision(self) -> Optional[int]:
        """
        The revision of this auto scaling configuration. It's unique among all the active configurations ("Status": "ACTIVE") that share the same AutoScalingConfigurationName.
        """
        return pulumi.get(self, "auto_scaling_configuration_revision")

    @property
    @pulumi.getter
    def latest(self) -> Optional[bool]:
        """
        It's set to true for the configuration with the highest Revision among all configurations that share the same AutoScalingConfigurationName. It's set to false otherwise. App Runner temporarily doubles the number of provisioned instances during deployments, to maintain the same capacity for both old and new code.
        """
        return pulumi.get(self, "latest")


class AwaitableGetAutoScalingConfigurationResult(GetAutoScalingConfigurationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAutoScalingConfigurationResult(
            auto_scaling_configuration_arn=self.auto_scaling_configuration_arn,
            auto_scaling_configuration_revision=self.auto_scaling_configuration_revision,
            latest=self.latest)


def get_auto_scaling_configuration(auto_scaling_configuration_arn: Optional[str] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAutoScalingConfigurationResult:
    """
    Describes an AWS App Runner automatic configuration resource that enables automatic scaling of instances used to process web requests. You can share an auto scaling configuration across multiple services.


    :param str auto_scaling_configuration_arn: The Amazon Resource Name (ARN) of this auto scaling configuration.
    """
    __args__ = dict()
    __args__['autoScalingConfigurationArn'] = auto_scaling_configuration_arn
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws-native:apprunner:getAutoScalingConfiguration', __args__, opts=opts, typ=GetAutoScalingConfigurationResult).value

    return AwaitableGetAutoScalingConfigurationResult(
        auto_scaling_configuration_arn=pulumi.get(__ret__, 'auto_scaling_configuration_arn'),
        auto_scaling_configuration_revision=pulumi.get(__ret__, 'auto_scaling_configuration_revision'),
        latest=pulumi.get(__ret__, 'latest'))


@_utilities.lift_output_func(get_auto_scaling_configuration)
def get_auto_scaling_configuration_output(auto_scaling_configuration_arn: Optional[pulumi.Input[str]] = None,
                                          opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAutoScalingConfigurationResult]:
    """
    Describes an AWS App Runner automatic configuration resource that enables automatic scaling of instances used to process web requests. You can share an auto scaling configuration across multiple services.


    :param str auto_scaling_configuration_arn: The Amazon Resource Name (ARN) of this auto scaling configuration.
    """
    ...
