# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetRolePolicyResult',
    'AwaitableGetRolePolicyResult',
    'get_role_policy',
    'get_role_policy_output',
]

@pulumi.output_type
class GetRolePolicyResult:
    def __init__(__self__, policy_document=None):
        if policy_document and not isinstance(policy_document, dict):
            raise TypeError("Expected argument 'policy_document' to be a dict")
        pulumi.set(__self__, "policy_document", policy_document)

    @property
    @pulumi.getter(name="policyDocument")
    def policy_document(self) -> Optional[Any]:
        """
        The policy document.
        """
        return pulumi.get(self, "policy_document")


class AwaitableGetRolePolicyResult(GetRolePolicyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRolePolicyResult(
            policy_document=self.policy_document)


def get_role_policy(policy_name: Optional[str] = None,
                    role_name: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRolePolicyResult:
    """
    Schema for IAM Role Policy


    :param str policy_name: The friendly name (not ARN) identifying the policy.
    :param str role_name: The name of the policy document.
    """
    __args__ = dict()
    __args__['policyName'] = policy_name
    __args__['roleName'] = role_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws-native:iam:getRolePolicy', __args__, opts=opts, typ=GetRolePolicyResult).value

    return AwaitableGetRolePolicyResult(
        policy_document=pulumi.get(__ret__, 'policy_document'))


@_utilities.lift_output_func(get_role_policy)
def get_role_policy_output(policy_name: Optional[pulumi.Input[str]] = None,
                           role_name: Optional[pulumi.Input[str]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetRolePolicyResult]:
    """
    Schema for IAM Role Policy


    :param str policy_name: The friendly name (not ARN) identifying the policy.
    :param str role_name: The name of the policy document.
    """
    ...
