# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetUserPolicyResult',
    'AwaitableGetUserPolicyResult',
    'get_user_policy',
    'get_user_policy_output',
]

@pulumi.output_type
class GetUserPolicyResult:
    def __init__(__self__, policy_document=None):
        if policy_document and not isinstance(policy_document, dict):
            raise TypeError("Expected argument 'policy_document' to be a dict")
        pulumi.set(__self__, "policy_document", policy_document)

    @property
    @pulumi.getter(name="policyDocument")
    def policy_document(self) -> Optional[Any]:
        """
        The policy document.
        """
        return pulumi.get(self, "policy_document")


class AwaitableGetUserPolicyResult(GetUserPolicyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetUserPolicyResult(
            policy_document=self.policy_document)


def get_user_policy(policy_name: Optional[str] = None,
                    user_name: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetUserPolicyResult:
    """
    Schema for IAM User Policy


    :param str policy_name: The name of the policy document.
    :param str user_name: The name of the user to associate the policy with.
    """
    __args__ = dict()
    __args__['policyName'] = policy_name
    __args__['userName'] = user_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws-native:iam:getUserPolicy', __args__, opts=opts, typ=GetUserPolicyResult).value

    return AwaitableGetUserPolicyResult(
        policy_document=pulumi.get(__ret__, 'policy_document'))


@_utilities.lift_output_func(get_user_policy)
def get_user_policy_output(policy_name: Optional[pulumi.Input[str]] = None,
                           user_name: Optional[pulumi.Input[str]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetUserPolicyResult]:
    """
    Schema for IAM User Policy


    :param str policy_name: The name of the policy document.
    :param str user_name: The name of the user to associate the policy with.
    """
    ...
