# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['AccessorArgs', 'Accessor']

@pulumi.input_type
class AccessorArgs:
    def __init__(__self__, *,
                 accessor_type: pulumi.Input['AccessorType'],
                 network_type: Optional[pulumi.Input['AccessorNetworkAccessorType']] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input['AccessorTagArgs']]]] = None):
        """
        The set of arguments for constructing a Accessor resource.
        :param pulumi.Input[Sequence[pulumi.Input['AccessorTagArgs']]] tags: An array of key-value pairs to apply to this resource.
        """
        pulumi.set(__self__, "accessor_type", accessor_type)
        if network_type is not None:
            pulumi.set(__self__, "network_type", network_type)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="accessorType")
    def accessor_type(self) -> pulumi.Input['AccessorType']:
        return pulumi.get(self, "accessor_type")

    @accessor_type.setter
    def accessor_type(self, value: pulumi.Input['AccessorType']):
        pulumi.set(self, "accessor_type", value)

    @property
    @pulumi.getter(name="networkType")
    def network_type(self) -> Optional[pulumi.Input['AccessorNetworkAccessorType']]:
        return pulumi.get(self, "network_type")

    @network_type.setter
    def network_type(self, value: Optional[pulumi.Input['AccessorNetworkAccessorType']]):
        pulumi.set(self, "network_type", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AccessorTagArgs']]]]:
        """
        An array of key-value pairs to apply to this resource.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AccessorTagArgs']]]]):
        pulumi.set(self, "tags", value)


warnings.warn("""Accessor is not yet supported by AWS Native, so its creation will currently fail. Please use the classic AWS provider, if possible.""", DeprecationWarning)


class Accessor(pulumi.CustomResource):
    warnings.warn("""Accessor is not yet supported by AWS Native, so its creation will currently fail. Please use the classic AWS provider, if possible.""", DeprecationWarning)

    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 accessor_type: Optional[pulumi.Input['AccessorType']] = None,
                 network_type: Optional[pulumi.Input['AccessorNetworkAccessorType']] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AccessorTagArgs']]]]] = None,
                 __props__=None):
        """
        Definition of AWS::ManagedBlockchain::com.amazonaws.taiga.webservice.api#Accessor Resource Type

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AccessorTagArgs']]]] tags: An array of key-value pairs to apply to this resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AccessorArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Definition of AWS::ManagedBlockchain::com.amazonaws.taiga.webservice.api#Accessor Resource Type

        :param str resource_name: The name of the resource.
        :param AccessorArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AccessorArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 accessor_type: Optional[pulumi.Input['AccessorType']] = None,
                 network_type: Optional[pulumi.Input['AccessorNetworkAccessorType']] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AccessorTagArgs']]]]] = None,
                 __props__=None):
        pulumi.log.warn("""Accessor is deprecated: Accessor is not yet supported by AWS Native, so its creation will currently fail. Please use the classic AWS provider, if possible.""")
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AccessorArgs.__new__(AccessorArgs)

            if accessor_type is None and not opts.urn:
                raise TypeError("Missing required property 'accessor_type'")
            __props__.__dict__["accessor_type"] = accessor_type
            __props__.__dict__["network_type"] = network_type
            __props__.__dict__["tags"] = tags
            __props__.__dict__["arn"] = None
            __props__.__dict__["billing_token"] = None
            __props__.__dict__["creation_date"] = None
            __props__.__dict__["status"] = None
        replace_on_changes = pulumi.ResourceOptions(replace_on_changes=["accessor_type", "network_type"])
        opts = pulumi.ResourceOptions.merge(opts, replace_on_changes)
        super(Accessor, __self__).__init__(
            'aws-native:managedblockchain:Accessor',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'Accessor':
        """
        Get an existing Accessor resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = AccessorArgs.__new__(AccessorArgs)

        __props__.__dict__["accessor_type"] = None
        __props__.__dict__["arn"] = None
        __props__.__dict__["billing_token"] = None
        __props__.__dict__["creation_date"] = None
        __props__.__dict__["network_type"] = None
        __props__.__dict__["status"] = None
        __props__.__dict__["tags"] = None
        return Accessor(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accessorType")
    def accessor_type(self) -> pulumi.Output['AccessorType']:
        return pulumi.get(self, "accessor_type")

    @property
    @pulumi.getter
    def arn(self) -> pulumi.Output[str]:
        return pulumi.get(self, "arn")

    @property
    @pulumi.getter(name="billingToken")
    def billing_token(self) -> pulumi.Output[str]:
        return pulumi.get(self, "billing_token")

    @property
    @pulumi.getter(name="creationDate")
    def creation_date(self) -> pulumi.Output[str]:
        return pulumi.get(self, "creation_date")

    @property
    @pulumi.getter(name="networkType")
    def network_type(self) -> pulumi.Output[Optional['AccessorNetworkAccessorType']]:
        return pulumi.get(self, "network_type")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output['AccessorStatus']:
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Sequence['outputs.AccessorTag']]]:
        """
        An array of key-value pairs to apply to this resource.
        """
        return pulumi.get(self, "tags")

